/*==================================================
	project:       CEQ Bulgaria 
	Author:        Robayo-Abril & Cabrera 
	E-email:       
	url:           
	Dependencies:  World Bank 
	----------------------------------------------------
	Creation Date:       10 Dec 2021
	Modification Date:   7 Jan 2021 
	Do-file version:    3
	References:          
	Output:             
==================================================*/

/*==================================================
0: Path==================================================*/

version 17
drop _all
set type double 
mat drop _all	
global path  "C:/Users/mynor/Dropbox (Personal)/zotros/BM/BGR20/"
if c(username)=="mcabrera1" global path  "E:/mcabrera/BGR20/"
global do    "${path}2.DOs/"
global raw   "${path}3.DATA/Original/raw/"
global tmp   "${path}3.DATA/MC/tmp/"
global proc  "${path}3.DATA/MC/proc/"
global log   "${path}3.DATA/MC/log/"
global outp   "${path}5.Output/"
include 	 "${do}ados/CEQ_BGR_prg.do"
sysdir set PLUS "${do}ados"


/*==================================================
	2: Check if ado files are installed
==================================================*/
** ssc install eurostatuse
** ssc install labeldatasyntax
** ssc install tabstatmat

/*==================================================
	3: Simulation parameters 
==================================================*/


scalar EXR = 1.9558


/*==================================================
	3: Run Do files 
==================================================*/


do "${do}1_BGR20_MarketIncome.do"

do "${do}2_BGR20_MarketIncomePPensions.do"

do "${do}3_BGR20_NetMarketIncome.do"

do "${do}4_BGR20_DispIncome.do"

do "${do}5_BGR20_IndTaxes.do"

do "${do}6_BGR20_Subsidies.do"

do "${do}7_BGR20_Education.do"

do "${do}8_BGR20_Health.do"

do "${do}9_BGR20_child_tables.do"  // To produce child poverty indicator 

do "${do}10_BGR20_sim_table3_Nov07_2023.do" // To produce policy scenarios 

	
/*
local escn   PDI  // PDI  PGT    ** correr PGT 2005
local ppa   2011    // 2011 2005

foreach y of local escn {

	foreach x of local ppa {
	
		do  "${do}BGR_AdoFiles_APR18_2022.do"  `x'  "${do}BGR_AdoFiles_APR18_2022.xlsx" 1  `y'

	}
	
}

*/


/*==================================================
	4: Output simulations 
==================================================*/


