
	local IDstudy "BGR20"
	local compare = 0
	local ben = 1
	local tar = 0
	
***************************************************************************

*1.-Compare datasets 

if `compare' == 1 {

 cf _all using "${MCData}"
/*
           yf_hh:  34867 mismatches
           yf_pc:  28488 mismatches
     hlt_allp_hh:  61922 mismatches
     hlt_allp_in:  56347 mismatches
     hlt_allp_pc:  61922 mismatches
*/
}

*2. Check income construction

    local pen "pen_*_pc"
	local dtx "dtx_*_pc con_*_pc"
	local con "cpn_*_pc"
	local dtr "dtr_*_pc"	
    local sub "sub_*_pc"	
	local itx "itx_vatx_pc  itx_oild_pc  itx_oili_pc  itx_beve_pc  itx_toba_pc"	
	local edu "edu_*_pc" 
	local feesedu ""
	local hlt "hlt_*_pc"
	local feeshlt ""
	local oth ""
	local feesoth ""

	foreach group in pen dtx con dtr sub itx edu hlt feesedu feeshlt {
		local a=wordcount("`group'")
		qui cap descr ``group'' 
		if !_rc & `a' > 0 {
			describe ``group''
		}
	}	
	*des `pen' `con' `dtx' `dtr' `sub' `itx'  `edu'  `hlt' 
	
	matrix INT=J(1,1,.)
	  
	foreach x of varlist  `dtx' `con' `itx' `feesedu' `feeshlt' { 
	sum `x'
	if  r(max) > 0 {
	replace `x'= -`x'
	}
	}
	
	
	foreach x in pen con dtx dtr sub itx edu hlt feesedu feeshlt { 
	local a=wordcount("``x''")
	qui cap descr ``x'' 
	display "`a' ---`x'"
	if !_rc & `a' > 0 {
		tabstat ``x'' [w=round(weight)], stat(sum) format(%15.3gc) col(stat) save
		tabstatmat `x' 
		mat `x' =`x' '
		mat INT= INT \ `x'
	}
	else {
		local `x' ""
	}
	
	}
	
	matrix list INT , format(%15.3gc)

**************************************
	
	tempvar checkyl checkyp checkye checkyn checkyk checkyg checkyr checkyd checkyc checkyf

	*PDI

		egen double `checkyl' = rowtotal(ym_pc `con')
		sum `checkyl' [w=round(weight)], meanonly
		scalar yl2= r(sum) 

		egen double `checkyp' = rowtotal(`checkyl' `pen') 
		sum `checkyp' [w=round(weight)]
		scalar yp2= r(sum) 

	/*	
	*PGT

		egen double `checkye' = rowtotal(ym_pc `pen') 
		sum `checkye' [w=round(weight)]
		scalar ye2= r(sum) 
	*/
	*PDI
	
		egen double  `checkyn' = rowtotal(yp_pc `dtx')
		sum `checkyn' [w=round(weight)]
		scalar yn2= r(sum) 

	/*	
	*PGT

		egen double `checkyk' = rowtotal(ym_pc `dtx' `con')
		sum `checkyk' [w=round(weight)]
		scalar yk2= r(sum) 
	*/
	*PDI

		egen double `checkyg' = rowtotal(yp_pc `dtr' )
		sum `checkyg' [w=round(weight)]
		scalar yg2= r(sum) 
	/*	
	*PGT

		egen double  `checkyr' = rowtotal(ym_pc `dtr' `pen')
		sum `checkyr' [w=round(weight)]
		scalar yr2= r(sum) 
	*/
	egen double `checkyd' = rowtotal(`checkyp' `dtr' `dtx')
	sum `checkyd' [w=round(weight)]
scalar yd2= r(sum) 
	
	egen double `checkyc' = rowtotal(`checkyd' `sub' `itx')
	sum `checkyc' [w=round(weight)]
	scalar yc2= r(sum) 
	
	egen double `checkyf' = rowtotal(`checkyc' `edu' `hlt' `feesedu' `feeshlt')
	sum `checkyf' [w=round(weight)]
	scalar yf2=r(sum) 
	
	loc i 2
	matrix INC=J(11,3,.)


	foreach x in /*yl*/ yp /*ye*/ yn /*yk*/ yg /*yr*/ yd yc yf { 
	sum  `x'_pc [w=round(weight)]
	scalar `x'1 = r(sum)
	mat INC[`i',1]=`x'1
	mat INC[`i',2]=`x'2
	scalar `x'3 = `x'2 -`x'1
	mat INC[`i',3]=`x'3
	local ++i
	} 
	
    sum ym_pc [w=round(weight)]
	mat INC[1,1]=r(sum)
	matrix rown INC = ym /*yl*/ yp /*ye*/ yn /*yk*/ yg /*yr*/ yd yc yf
	matrix list INC , format(%20.0gc)
	
*3. Check beneficiaries
if `ben' == 1 {

    local pen_r "pen_*_r*"
	local dtx_r  "dtx_*_r* con_*_r*"
	local con_r "cpn_*_r*"
	local dtr_r  "dtr_*_r*"	
    local sub_r "sub_*_r*"	
	local itx_r "itx_vatx_rh  itx_oild_rh  itx_oili_rh  itx_beve_rh  itx_toba_rh"	
	local edu_r "edu_*_r*" 
	local feesedu_r ""
	local hlt_r "hlt_*_r*"
	local feeshlt_r ""
	local oth_r ""
	local feesoth_r ""

	foreach group in pen_r dtx_r con_r dtr_r sub_r itx edu_r hlt_r {
		local a=wordcount("``group''")		
		qui cap descr ``group''
		if !_rc & `a'>0 {
			describe ``group''
		}
	}	

	*des `pen_r' `con_r' `dtx_r' `dtr_r' `sub_r' `itx_r'  `edu_r'  `hlt_r'  
	
	matrix BEN=J(1,1,.)

	foreach x in pen_r con_r dtx_r dtr_r sub_r itx_r edu_r hlt_r { 
	local a=wordcount("``x''")
	qui cap descr ``x'' 
	if !_rc & `a' > 0 {
	tabstat ``x'' [w=round(weight)], stat(sum) format(%15.3gc) col(stat) save
	tabstatmat `x' 
	mat `x' =`x' '
	mat BEN= BEN \ `x'
	}	
	}
	matrix list BEN , format(%15.3gc)

	matrix OBS=J(1,1,.)

	foreach x in pen_r con_r dtx_r dtr_r sub_r itx_r edu_r hlt_r { 
		local a=wordcount("``x''")
		qui cap descr ``x''		
		
	if !_rc & `a'>0 {
			tabstat ``x'' , stat(sum) format(%15.3gc) col(stat) save
			tabstatmat `x' 
			mat `x' =`x' '
			mat OBS= OBS \ `x'
		}
		else {
			local `x' ""
		}	
	}
	
	matrix list OBS , format(%15.3gc)
}

*4. Check target population
if `tar' == 1 {

    local pen_t "pen_*_t*"
	local dtx_t "dtx_*_t* con_*_t*"
	local con_t "cpn_*_t*"
	local dtr_t "dtr_*_t*"	
    local sub_t "sub_*_t*"	
	local edu_t "edu_*_t*" 
	local feesedu_t ""
	local hlt_t "hlt_*_t*"
	local feeshlt_t ""
	local oth_t ""
	local feesoth_t ""

	des `pen_t' `dtr_t' `edu_t' `hlt_t' // `dtx_t' `con_t' `sub_t'  
	
	matrix TAR=J(1,1,.)

	foreach x in pen_t dtr_t edu_t hlt_t { // dtx_t con_t sub_t
	
	tabstat ``x'' [w=round(weight)], stat(sum) format(%15.3gc) col(stat) save
	tabstatmat `x' 
	mat `x' =`x' '
	mat TAR= TAR \ `x'
	}
	
	matrix list TAR , format(%15.3gc)
}
*5.Write in Excel

	local filedate  :di %tdDDMonCCYY date("$S_DATE","DMY", 2050)
	putexcel set "${proc}/`IDstudy'_IncomeConstruction_`filedate'.xlsx",  sheet(IncomeConstruction) modify
	
	*LCU totals
	putexcel B7 = matrix(INT), rownames nformat(number_sep_negbra) overwritefmt 
	putexcel K8 = matrix(INC), rownames nformat(number_sep_negbra) overwritefmt 

	*Observations
	if `ben' == 1 {
	
	putexcel E7 = matrix(OBS), rownames nformat(number_sep_negbra) overwritefmt 

	*Beneficiaries/Payers
	putexcel D7 = matrix(BEN), rownames nformat(number_sep_negbra) overwritefmt 
}
	*Target
	if `tar' == 1 {

	putexcel G7 = matrix(TAR), rownames nformat(number_sep_negbra) overwritefmt 
}

	putexcel J8   ="MI PGT"   , left font(italic, 10, "lightgray")
/*putexcel J9 ="MI PDI" , left font(italic, 10, "lightgray") */
	putexcel J9   ="MI+P PDI" , left font(italic, 10, "lightgray")
/*putexcel J10  ="MI+P PGT", left font(italic, 10, "lightgray")*/
	putexcel J10  ="NMI PDI" , left font(italic, 10, "lightgray")
	/*putexcel J12  ="NMI PGT" , left font(italic, 10, "lightgray")*/
	putexcel J11  ="GI PDI"  , left font(italic, 10, "lightgray")
	/*putexcel J14  ="GI PGT"  , left font(italic, 10, "lightgray")*/

	putexcel B2="Income Construction", bold left
	putexcel B7=""
	putexcel D7=""
	putexcel C7="LCU Totals", bold hcenter vcenter fpattern(solid, "lightblue")
	putexcel E7="Beneficiaries/Payers", txtwrap bold hcenter vcenter fpattern(solid, "lightblue")
	putexcel F7="Observations", txtwrap bold hcenter vcenter fpattern(solid, "lightblue")
	putexcel L7="Totals from the survey", txtwrap bold hcenter vcenter fpattern(solid, "lightblue")
	putexcel M7="Construction", txtwrap bold hcenter vcenter fpattern(solid, "lightblue")
	putexcel N7="Diff", txtwrap bold hcenter vcenter fpattern(solid, "lightblue")
	putexcel G7=""
	putexcel H7="Target", bold hcenter vcenter fpattern(solid, "lightblue")

	putexcel (A2:Z2), bold font("Calibri", 16, "white") fpattern(solid, "darkblue")
	
	
	exit
	
