** Programs CEQ BGR ------------------------------------------------------------

local clnprg povcc percap rpayi rpayh labhip lab_rh lab_ri

foreach x of local clnprg {
	cap program drop `x'
}	

set seed 34401722	

** Poverty 
program define povcc
syntax varlist [if] [iweight fweight] [, pline(string) nn(string) ppof(string)] 

// Implement [if]
	
  marksample touse
  
  local pl = `pline'

foreach x of varlist `varlist' {
tempvar po_ pof
gen `po_'=(`x'<=`pl') if `touse'
summ `po_'  [`weight'`exp'] if `touse', meanonly
local ppo_=r(mean)*100
di as text "`nn':" as result %6.2fc `ppo_' as text ", official:" as result %6.2fc `ppof'
}

end 


** Per capita variables 

	program percap
	syntax varlist 
	foreach x of varlist `varlist' {	
	local hh 	  
	local fint=substr("`x'",-2,.)
	if "`fint'"=="in"  {	 
		local hh2 = subinstr("`x'","_in","_hh",1)
		local pc3 = subinstr("`x'","_in","_pc",1)
		cap drop `hh2'
		cap drop `pc3'
		bysort hhid: egen double `hh2'=sum(`x')		
		gen double `pc3'=(`hh2'/hsize)	  
	}
	if "`fint'"=="hh" {	  		
		local pc3 = subinstr("`x'","_hh","_pc",1)
		tempvar maxhh 		
		replace `x' =0 if `x'==.
		bysort hhid: egen double `maxhh' = max(`x')
		replace `x' = `maxhh'		
		cap drop `pc3'		
		gen double `pc3'=(`x'/hsize)	  
	}
	labhip `x'
}
end

** Payers / Beneficiaries individual 
program rpayi 
syntax varlist
foreach x of varlist `varlist'  {
	local fint=substr("`x'",-2,.)
	local y=substr("`x'",1,3)
	if "`fint'"=="in"   {		
		local rpayz = substr("`x'",1,strlen("`x'")-2)+"ri"
		cap drop `rpayz'
		gen `rpayz' = (`x'>0 & `x'<.)
		local a: variable label `x'
		if "`a'"!=""  {
			local lpayz = regexr("`a'","\((I|i)ndividual\)","")			
			if regexm("`x'","cpn|con|dtx|itx|fee") 	local payz "Payers of `lpayz'"
			if regexm("`x'","pen|dtr|sub|hlt|edu") 	local payz "Recipients of `lpayz'"
			label var `rpayz' "`payz'"
			label val `rpayz' yesno
		}	
	}
	
}
end 
***************************************

** Payers / Beneficiaries hhd  
program rpayh 
syntax varlist
foreach x of varlist `varlist' {
	local fint=substr("`x'",-2,.)
	local y=substr("`x'",1,3)
	if "`fint'"=="hh" {
		local rpayz = subinstr("`x'","hh","rh",1)
		cap drop `rpayz'
		gen `rpayz' = (`x'>0 & `x'!=.)
		replace `rpayz'=0 if memb_no!=1			
		local a: variable label `x'
		if "`a'"!="" {
			local lpayz = regexr("`a'","\((H|h)ousehold\)|\((P|p)er (C|c)apita\)","")
*			local lpayz = subinstr("`lpayz'","(household)","",.)
			if regexm("`x'","cpn|con|dtx|itx|fee") 	local payz "Payers of `lpayz'"
			if regexm("`x'","pen|dtr|sub|hlt|edu") 	local payz "Recipients of `lpayz'"
			label var `rpayz' "`payz'"
		}	
	}
	
	if "`fint'"=="pc" {
		local rpayz = subinstr("`x'","pc","rh",1)
		cap drop `rpayz'
		gen `rpayz' = (`x'>0 & `x'!=.)
		replace `rpayz'=0 if memb_no!=1			
		local a: variable label `x'
		if "`a'"!="" {
			local lpayz = regexr("`a'","\((H|h)ousehold\)|\((P|p)er (C|c)apita\)","")
			*local lpayz = subinstr("`a'","(Household)","",.)
			*local lpayz = subinstr("`lpayz'","(household)","",.)
			if regexm("`x'","cpn|con|dtx|itx|fee") local payz "Payers of `lpayz'"
			if regexm("`x'","pen|dtr|sub|hlt|edu") local payz "Recipients of `lpayz'"
			label var `rpayz' "`payz'"
		}	
	}
	capture confirm variable `rpayz' 
	if !_rc label val `rpayz' yesno 
}	
end 

*"
program labhip 
syntax varlist 
foreach x of varlist `varlist' {
	local a: variable label `x'
	local fint=substr("`x'",-2,.)
	if "`fint'"=="pc" {
		local labpc = 0
		local finthh=subinstr("`x'","_pc","_hh",1)
		cap confirm variable `finthh'
		if !_rc {
			local ahh = regexr("`a'",  "(P|p)er capita", "Household")
			local labhh=1
		}
		local fintin=subinstr("`x'","_pc","_in",1)
		cap confirm variable `fintin'		
		if !_rc {
			local ain = regexr("`a'",  "(P|p)er capita", "Individual")
			local labin=1
		}
	}
	if "`fint'"=="hh" {
		local labhh = 0
		local fintpc=subinstr("`x'","_hh","_pc",1)
		cap confirm variable `fintpc'
		if !_rc {
			local apc = regexr("`a'",  "(H|h)ousehold", "Per capita")
			local labpc=1
		}
		local fintin=subinstr("`x'","_hh","_in",1)
		cap confirm variable `fintin'
		if !_rc {
			local ain = regexr("`a'",  "(H|h)ousehold", "Per capita")
			local labin=1
		}
	}
	if "`fint'"=="in" {
		local labin = 0
		local fintpc=subinstr("`x'","_in","_pc",1)
		cap confirm variable `fintpc'
		if !_rc {
			local apc = regexr("`a'",  "(I|i)ndividual", "Per capita")
			local labpc=1
		}
		local finthh=subinstr("`x'","_in","_hh",1)
		cap confirm variable `finthh'
		if !_rc {
			local ahh = regexr("`a'",  "(I|i)ndividual", "Household")						
			local labhh=1
		}
	}
	
	if "`labhh'"=="1" 	label variable `finthh' "`ahh'"	
	if "`labpc'"=="1" 	label variable `fintpc' "`apc'"
	if "`labin'"=="1" 	label variable `fintin' "`ain'"
	
	}
	
	end
	
	cap program drop lab_torh
	program define lab_torh 
	syntax varlist 
	foreach x of varlist `varlist' {	
		local hpc = regexr("`x'","rh","pc")		
		cap confirm variable `hpc' 
		if _rc {
			local hpc = regexr("`x'","rh","hh")		
		}				
		local a: variable label `hpc'
		local lpayz = regexr("`a'","\((H|h)ousehold\)|\((P|p)er (C|c)apita\)","")						
		
		if "`a'"!="" {			
			if regexm("`x'","cpn|con|dtx|itx|fee") 	local payz "Payers of `lpayz'"
			if regexm("`x'","pen|dtr|sub|hlt|edu") 	local payz "Recipients of `lpayz'"
			label var `x' "`payz'"
		}	
	}
	end 
	
	cap program drop lab_tori
	program define lab_tori 
	syntax varlist 
	foreach x of varlist `varlist' {	
		local hpc = regexr("`x'","ri","pc")		
		cap confirm variable `hpc' 
		if _rc {
			local hpc = regexr("`x'","ri","in")		
		}				
		local a: variable label `hpc'
		local lpayz = regexr("`a'","\((I|n)dividual\)|\((P|p)er (C|c)apita\)","")						
		
		if "`a'"!="" {			
			if regexm("`x'","cpn|con|dtx|itx|fee") 	local payz "Payers of `lpayz'"
			if regexm("`x'","pen|dtr|sub|hlt|edu") 	local payz "Recipients of `lpayz'"
			label var `x' "`payz'"
		}	
	}
	end 
	
	
	program define lab_ri
	syntax varlist 
	foreach x of varlist `varlist' {
		local a: variable label `x'
		local fint=substr("`x'",-2,.)
		local rpayz = subinstr("`x'","in","ri",1)	
		local a: variable label `x'
		if "`a'"!="" {
			local lpayz = regexr("`a'","\((I|n)dividual\)|\((P|p)er (C|c)apita\)","")
			if regexm("`x'","cpn|con|dtx|itx|fee") 	local payz "Payers of `lpayz'"
			if regexm("`x'","pen|dtr|sub|hlt|edu") 	local payz "Recipients of `lpayz'"
			label var `rpayz' "`payz'"
		}	
	}
	end 
	
	