
*datalibweb, coun(bgr) y(2019) t(eusilc) module(h) clear
*datalibweb, coun(bgr) y(2019) t(eusilc) module(r) clear
*datalibweb, coun(bgr) y(2019) t(eusilc) module(p) clear
*datalibweb, coun(bgr) y(2019) t(eusilc) module(d) clear

*datalibweb, coun(bgr) y(2016) t(eusilc) module(d h) clear
*save "C:\Users\wb191173\OneDrive - WBG\!My Documents\!WorldBank\Lucru Desktop\ECA\Bulgaria\Stata\eusilc_dh16.dta", replace
*datalibweb, coun(bgr) y(2017) t(eusilc) module(d h) clear
*save "C:\Users\wb191173\OneDrive - WBG\!My Documents\!WorldBank\Lucru Desktop\ECA\Bulgaria\Stata\eusilc_dh17.dta", replace
*datalibweb, coun(bgr) y(2018) t(eusilc) module(d h) clear
*save "C:\Users\wb191173\OneDrive - WBG\!My Documents\!WorldBank\Lucru Desktop\ECA\Bulgaria\Stata\eusilc_dh18.dta", replace
*datalibweb, coun(bgr) y(2019) t(eusilc) module(d h) clear
*save "C:\Users\wb191173\OneDrive - WBG\!My Documents\!WorldBank\Lucru Desktop\ECA\Bulgaria\Stata\eusilc_dh19.dta", replace


*datalibweb, coun(bgr) y(2016) t(eusilc) module(r p) clear
*save "C:\Users\wb191173\OneDrive - WBG\!My Documents\!WorldBank\Lucru Desktop\ECA\Bulgaria\Stata\eusilc_rp16.dta", replace
*datalibweb, coun(bgr) y(2017) t(eusilc) module(r p) clear
*save "C:\Users\wb191173\OneDrive - WBG\!My Documents\!WorldBank\Lucru Desktop\ECA\Bulgaria\Stata\eusilc_rp17.dta", replace
*datalibweb, coun(bgr) y(2018) t(eusilc) module(r p) clear
*save "C:\Users\wb191173\OneDrive - WBG\!My Documents\!WorldBank\Lucru Desktop\ECA\Bulgaria\Stata\eusilc_rp18.dta", replace
*datalibweb, coun(bgr) y(2019) t(eusilc) module(r p) clear
*save "C:\Users\wb191173\OneDrive - WBG\!My Documents\!WorldBank\Lucru Desktop\ECA\Bulgaria\Stata\eusilc_rp19.dta", replace

*****************************************************************************************************************************************

/*==================================================
0: Path==================================================*/

version 17
drop _all
set type double 
global path  "C:/Users/mynor/Dropbox (Personal)/zotros/BM/BGR/"
global do    "${path}4.DOs/"
global raw   "${path}3.DATA/Original/raw/"
global tmp   "${path}3.DATA/MC/tmp/"
global proc  "${path}3.DATA/MC/proc/"
global log   "${path}3.DATA/MC/log/"
include 	 "${do}ados/CEQ_BGR_prg.do"


clear all
*cd "C:\Users\wb191173\OneDrive - WBG\!My Documents\!WorldBank\Lucru Desktop\ECA\Bulgaria\Stata"
cd "${raw}EU-SILC/"
/* 
use eusilc_dh17.dta, clear
append using eusilc_dh18.dta
append using eusilc_dh19.dta
sort year_n hhid_n
save eusilc_dh1719.dta, replace

cd "C:\Users\wb191173\OneDrive - WBG\!My Documents\!WorldBank\Lucru Desktop\ECA\Bulgaria\Stata"
use eusilc_rp17.dta, clear
append using eusilc_rp18.dta
append using eusilc_rp19.dta
save eusilc_rp1719.dta, replace
 */
 
frame create dh  

frame pwf 
frame change dh 
tempfile dh1 dh2 
 
use  "UDB_BG_d19.dta", clear 
count  
* 14,680
rename db030 hhid_n 
rename db060 year_n 
drop if hhid_n==.
count 
*7340

sort hhid_n 

save "`dh1'", replace 

use  "UDB_BG_h19.dta", clear 
count 
*  14,680

rename hb030 hhid_n 
rename hb060 year_n 
drop if hhid_n==.
count 
*7340

merge  1:1  hhid_n using "`dh1'"
count 
*7340
drop _*

save "`dh2'"

**-----------------------------------------------------------------------
frame create pr 
frame change pr 

tempfile rp1 rp2 
use  "UDB_BG_p19.dta", clear 
count  
* 29,960

rename px030 hhid_n 
rename pb010 year_n 
rename pb030 id_n 

drop if hhid_n==.
count 
* 14,980

sort id_n 

save "`rp1'", replace 

use  "UDB_BG_r19_ethnos.dta", clear 
count 
*    17,012

rename rx030 hhid_n 
rename rb010 year_n 
rename rb030 id_n 

drop if hhid_n==.
count 
*. count 
*  17,012

merge  1:1  id_n using "`rp1'"
count 
*7340
drop _*

save "`rp2'", replace 


 
recode py09*_f py1*_f (min/0=0) (1/max=1) // create participation indicators (0/1) in various SP schemes
collapse (sum) py09*n py09*g py09*_f py1*n py1*g py1*_f, by(year_n hhid_n)

drop py12* // DROP Sickness Benefits from SP benefits NOT IN CEQ 

recode py*_f (1/max=1), pre(h)  // count hhd benefits 

rename (py09*n py09*g py1*n py1*g) h=  // add h to all vars 

sort year_n hhid_n
save "`rp2'", replace

*use "`dh2'", clear
frame change dh 
merge 1:1 year_n hhid_n using "`rp2'"
rename _merge _mDHRPsp

gen pweight= db090*hx040 // population weights
gen hhpredi= hy022 // HH disposable income pre-transfer (minus transfers except old age and survivor - eu-silc definition)
recode hhpredi (min/0=0) // there are negative values

gen predi=hhpredi/hx050 // equivalized disposable income (EDI) pre-transfer (minus transfers except pensions and survivor benefits)

* EDI quintiles post-transfer (PAE)
	gen qedi=.
	foreach i in /* 2017 2018 */ 2019 {
		xtile q=hx090 if year==`i' [aw=pw], nq(5)
		replace qedi=q if year==`i'
		drop q
	}
	
* PREDI quintiles pre-transfer (PAE)
	gen qpredi=.
	foreach i in /* 2017 2018 */ 2019 {
		xtile q=predi if year==`i' [aw=pw], nq(5)
		replace qpredi=q if year==`i'
		drop q
	}

gen urban=db100
recode urban (2=1) (3=0)
	
*Participation

*All Social Protection - ESSPROS (we leave out sickness benefits hpy120)
recode hy05*f hy06*f hy07*f (min/0=0) (1/max=1)
gen spb_hh=hy050g_f>0 | hy060g_f>0 | hy070g_f>0 | hpy090g_f>0 | hpy100g_f>0 | hpy110g_f>0 | hpy130g_f>0 | hpy140g_f>0 // All SP 

gen famb_hh= hy050g_f>0 						// all "child and family" benefits (contributory and non-contributory)
gen soexb_hh= hy060g_f>0						// all "social exclusion" benefits (contributory and non-contributory)
gen ubb_hh= hpy090g_f>0						// all "unemployment" benefits (contributory and non-contributory)
gen oldageb_hh= hpy100g_f>0					// all "old-age" benefits (contributory and non-contributory)
gen disb_hh= hpy130g_f>0 					// all "disability" benefits (contributory and non-contributory)
gen otherspb_hh= hy070g_f>0 | hpy110g_f>0 | hpy140g_f>0 	// all other SP benefits

* All SP Incomes/ Benefits/ Transfers - ESSPROS classification (without sickness benefits, and net)
gen ifamb_hh= hy050n 						// all "child and family" benefits (contributory and non-contributory)
gen isoexb_hh= hy060n					// all "social exclusion" benefits (contributory and non-contributory)
gen iubb_hh= hpy090n						// all "unemployment" benefits (contributory and non-contributory)
gen ioldageb_hh= hpy100n					// all "old-age" benefits (contributory and non-contributory)
gen idisb_hh= hpy130n 					// all "disability" benefits (contributory and non-contributory)
egen iotherspb_hh= rsum(hy070n hpy110n hpy140n) 	// all other SP benefits
egen ispb_hh= rsum(hy050n hy060n hy070n hpy090n hpy100n hpy110n hpy130n hpy140n)
recode i*_hh (.=0)

*Social Assistance: larger programs 
gen famsab_hh= hy053g_f>0 | hy054g_f>0 		// social assistance family benefits (all non-contributory)
gen soexsab_hh= hy063g_f>0 | hy064g_f>0	 	// all non-contributory social exclusion 
gen oldissab_hh= hpy103g_f>0 | hpy104g_f>0 | hpy133g_f>0 | hpy134g_f>0	// old age and disability social assistance (individual); in 2019 there were shifts in numbers from old age to disability maybe because measurement/ definition  
*gen oldsab_hh= hpy103g_f>0 | hpy104g_f>0 	// old age social assistance (individual)
*gen dissab_hh= hpy133g_f>0 | hpy134g_f>0 	// disability social assistance (individual)
gen othersab_hh= hy073g_f>0 | hpy093g_f>0 | hpy113g_f>0 | hpy143g_f>0 | hy074g_f>0 | hpy094g_f>0 | hpy114g_f>0 | hpy144g_f>0 // all other non-contributory benefits

egen indsab_hh= rsum(hpy*3g_f hpy*4g_f)		// individual non-contributory benefits
recode indsab_hh (1/max=1)

*All Social Assistance
gen sab_hh= hy053g_f>0 | hy054g_f>0 | hy063g_f>0 | hy064g_f>0 | hy073g_f>0 | hy074g_f>0 | indsab_hh>0	// All SA

*Social Assistance Incomes/ Benefits/ Transfers
egen ifamsab_hh= rsum(hy053g hy054g)		 			// social assistance family benefits (all non-contributory)
egen isoexsab_hh= rsum(hy063g hy064g) 					// all non-contributory social exclusion 
egen ioldissab_hh= rsum(hpy103g hpy104g hpy133g hpy134g) 				// old age and disability social assistance (individual); there were shifts in numbers maybe due to measurement/ definition or legislation in 2019
*egen ioldsab_hh= rsum(hpy103g hpy104g) 				// old age social assistance (individual)
*egen idissab_hh= rsum(hpy133g hpy134g)	 				// disability social assistance (individual)
egen iothersab_hh= rsum(hy073g hpy093g hpy113g hpy143g hy074g hpy094g hpy114g hpy144g) // all other non-contributory benefits

egen iindsab_hh= rsum(hpy*3g hpy*4g)
egen isab_hh= rsum(hy053g hy054g hy063g hy064g hy073g hy074g iindsab_hh)	// Incomes from All SA 

*All Social Assistance: Means-Tested and Non-Means-Tested (larger programs)
gen mtfamb_hh= hy053g_f>0 							// means-tested non-contributory child and family benefits 
gen mtsoexb_hh= hy063g_f>0 							// means-tested non-contributory social exclusion (social benefit and heating allowance)
gen mtotherb_hh= hy073g_f>0 | hpy093g_f>0 | hpy103g_f>0 | hpy113g_f>0 | hpy133g_f>0 | hpy143g_f>0 	// all other means tested social assistance
gen nmtoldisb_hh= hpy104g_f>0 | hpy134g_f>0		// non-MT old age and disability social assistance (individual); in 2019 there was a change in numbers maybe because measurement/ definition or legislation)
gen nmtotherb_hh= hy054g_f>0 | hy064g_f>0 | hy074g_f>0 | hpy094g_f>0 | hpy114g_f>0 | hpy144g_f>0 // all other non-MT non-contributory benefits, mostly Family Benefits


egen mtindb_hh= rsum(hpy*3g_f)											// individual non-contributory means-tested benefits
recode mtindb_hh (1/max=1)
egen nmtindb_hh= rsum(hpy*4g_f)											// individual non-contributory non-MT benefits
recode nmtindb_hh (1/max=1)

gen mtsab_hh= hy053g_f>0 | hy063g_f>0 | hy073g_f>0 | mtindb_hh>0		// All Means-Tested SA
gen nmtsab_hh= hy054g_f>0 | hy064g_f>0 | hy074g_f>0 | nmtindb_hh>0		// All non-MT SA


*Means Tested SA Incomes/ Benefits/ Transfers
gen imtfamb_hh= hy053g 										// means-tested non-contributory child and family benefits 
gen imtsoexb_hh= hy063g	 									// means-tested non-contributory social exclusion (social benefit and heating allowance)
egen imtotherb_hh= rsum(hy073g	hpy093g hpy103g hpy113g hpy133g hpy143g) 	// all other means tested social assistance
egen inmtoldisb_hh= rsum(hpy104g hpy134g) 					// non-MT old age and disability social assistance (individual); in 2019 there was a shift in numbers from old age to disability - maybe change of defintion/ measurement/ legislation
egen inmtotherb_hh= rsum(hy054g hy064g hy074g hpy094g hpy114g hpy144g) 		// all other non-MT non-contributory benefits, mostly Family Benefits

egen imtindb_hh= rsum(hpy*3g)											// individual non-contributory means-tested benefits
egen inmtindb_hh= rsum(hpy*4g)											// individual non-contributory non-MT benefits

egen imtsab_hh= rsum(hy053g hy063g hy073g mtindb_hh)		// All Means-Tested SA
egen inmtsab_hh= rsum(hy054g hy064g hy074g nmtindb_hh)		// All non-MT SA


*Social Insurance (contributory)

*All Social Insurance (we leave out sickness benefits; there is no means-tested contributory benefit; leaving out all benefits with no contributory component)
gen oldsib_hh= hpy102g_f>0 
gen ubsib_hh= hpy092g_f>0
gen dissib_hh= hpy132g_f>0
gen othersib_hh= hy052g_f>0 | hpy112g_f>0

gen sib_hh= hy052g_f>0 |  hpy092g_f>0 | hpy102g_f>0 | hpy112g_f>0 | hpy132g_f>0

*Social Insurance Incomes/ Benefits/ Transfers
gen ioldsib_hh= hpy102g 
gen iubsib_hh= hpy092g
gen idissib_hh= hpy132g
egen iothersib_hh= rsum(hy052g hpy112g)

egen isib_hh= rsum (hy052g  hpy092g hpy102g hpy112g hpy132g)

*Generate welfare aggregate (EDI) pre- social assistance (presadi)
gen hhpresadi=hy020-isab_hh
recode hhpresadi (min/0=0)
gen presadi=hhpresadi/ hx050

* PREDI quintiles pre-social assistance (PAE)
	gen qpresadi=.
	foreach i in /* 2017 2018 */ 2019 {
		xtile q=presadi if year==`i' [aw=pw], nq(5)
		replace qpresadi=q if year==`i'
		drop q
	}
	

sort year_n hhid_n
tempfile hh_dhrp 
save `hh_dhrp', replace

/*For ADEPT
preserve
saveold adept_1719, replace
restore, preserve
foreach i in /* 2017 2018 */ 2019 {
keep if year_n == `i'
         saveold adept`i', replace
         restore, preserve 
 }
exit
 */       


tab qpredi hpy090g_f [aw=pw], nof col
tab qpredi hpy100g_f [aw=pw], nof col
tab qpredi hpy130g_f [aw=pw], nof col
tab qpredi famb_hh   [aw=pw], nof col
tab qpredi soexb_hh  [aw=pw], nof col
tab qpredi sab_hh    [aw=pw], nof col
tab qpredi spb_hh    [aw=pw], nof col

tab qpredi hpy090g_f [aw=pw], nof cell
tab qpredi hpy100g_f [aw=pw], nof cell
tab qpredi hpy130g_f [aw=pw], nof cell
tab qpredi famb_hh   [aw=pw], nof cell
tab qpredi soexb_hh  [aw=pw], nof cell
tab qpredi sab_hh    [aw=pw], nof cell
tab qpredi spb_hh    [aw=pw], nof cell

table qpredi [iw=pw], stat(mean hpy090g_f) 
table qpredi [iw=pw], stat(mean hpy100g_f) 
table qpredi [iw=pw], stat(mean hpy130g_f) 
table qpredi [iw=pw], stat(mean famb_hh) 
table qpredi [iw=pw], stat(mean soexb_hh) 
table qpredi [iw=pw], stat(mean sab_hh) 
table qpredi [iw=pw], stat(mean spb_hh)   

table qpredi hpy090g_f [iw=pw], stat(sumw ) 
table qpredi hpy100g_f [iw=pw], stat(sumw ) 
table qpredi hpy130g_f [iw=pw], stat(sumw ) 
table qpredi famb_hh   [iw=pw], stat(sumw ) 
table qpredi soexb_hh  [iw=pw], stat(sumw ) 
table qpredi sab_hh    [iw=pw], stat(sumw ) 
table qpredi spb_hh    [iw=pw], stat(sumw ) 

tab qpredi qedi [aw=pw], nof ro cell

* only means tested HH/ family level social assistance benefits
tab qpredi mtfamb_hh  [aw=pw], nof col
tab qpredi mtsoexb_hh [aw=pw], nof col
tab qpredi mtsab_hh   [aw=pw], nof col

table qpredi [iw=pw], stat(mean mtfamb_hh) 
table qpredi [iw=pw], stat(mean mtsoexb_hh)
table qpredi [iw=pw], stat(mean mtsab_hh) 

table qpredi mtfamb_hh  [iw=pw],  stat(sumw) 
table qpredi mtsoexb_hh [iw=pw],  stat(sumw) 
table qpredi mtsab_hh   [iw=pw],  stat(sumw) 

* household weights - to compare with admin data
table qpredi mtfamb_hh  [iw=db090], stat(sumw)
table qpredi mtsoexb_hh [iw=db090], stat(sumw)
table qpredi mtsab_hh   [iw=db090], stat(sumw)

tabstat mtfamb_hh mtsoexb_hh mtsab_hh [w=db090], stat(sum) format(%15.0fc)


tabstat ifamb_hh idisb_hh hpy090n hpy100n hpy130n  isoexb_hh isab_hh ispb_hh, ///
	stat(sum) format(%15.0fc) col(stat)
	
tabstat ifamb_hh idissib_hh ioldissab_hh ioldsib_hh iubb_hh iotherspb_hh isoexb_hh [w=db090], ///
	stat(sum) format(%15.0fc) col(stat)	save

/*
    Variable |             Sum
-------------+----------------
    ifamb_hh |     700,837,559
  idissib_hh |     396,009,995
ioldissab_hh |     137,426,882
  ioldsib_hh |   4,157,873,217
     iubb_hh |     227,532,381
iotherspb_hh |     137,495,059
   isoexb_hh |      87,238,337
------------------------------


*/
	
	
	
tabstatmat dtr1
mat dtr1 = dtr1'
mata: dt_1 = st_matrix("dtr1")	
mata: dt_2 = colsum(dt_1[1::3,1])+colsum(dt_1[5::7,1])
mata: dt_3 = colsum(dt_1[,1])
mata: st_matrix("dtr2", (dt_2, dt_3))

matlist dtr2, format(%16.0fc)

/*
. matlist dtr2, format(%16.0fc)

             |               c1                c2 
-------------+------------------------------------
          r1 |    1,686,540,213     5,844,413,430 
*/

	