label define hb110 1 "One-person household" 2 "Lone parent with at least one child aged less than 25" 3 "Lone parent with all children aged 25 or more" 4 "Couple without any child(ren)" 5 "Couple with at least one child aged less than 25" 6 "Couple with all children aged 25 or more" 7 "Other type of household"
label define hh010 1 "Detached house" 2 "Semi-detached or terraced house" 3 "Apartment or flat in a building with less than 10 dwellings" 4 "Apartment or flat in a building with 10 or more dwellings" 5 "Some other kind of accommodation"
label define hh021 1 "Owner without outstanding mortgage" 2 "Owner with outstanding mortgage" 3 "Tenant, rent at market price" 4 "Tenant, rent at reduced price" 5 "Tenant, rent free"
label define hh050 1 "Yes" 2 "No"

label values hb110 hb110
label values hh010 hh010
label values hh021 hh021
label values hh050 hh050

label variable hb010 "Year of the survey" 
label variable hb020 "Country alphanumeric" 
label variable hb030 "Household ID" 
label variable hb050 "Quarter of household interview" 
label variable hb050_f "Flag" 
label variable hb060 "Year of household interview" 
label variable hb060_f "Flag" 
label variable hb070 "Person responding to household questionnaire" 
label variable hb070_f "Flag" 
label variable hb100 "Number of minutes to complete the household questionnaire" 
label variable hb100_f "Flag" 
label variable hb110 "Household type (IT: removed)" 
label variable hb110_f "Flag" 
label variable hb120 "Household size (DE: deleted 7 or more, MT: top-coded 6=6+)" 
label variable hb120_f "Flag" 
label variable hb130 "Interview mode used (household)" 
label variable hb130_f "Flag" 
label variable hy010 "Total household gross income (DE, EE, MT, SI, UK: Adjustments; MT: T & b cod)" 
label variable hy010_f "Flag" 
label variable hy010_i "Imputation factor" 
label variable hy020 "Total disposable hh income (DE,EE,MT,SI,UK: Adj; MT: T&b cod, FR,IE: rounded)" 
label variable hy020_f "Flag" 
label variable hy020_i "Imputation factor" 
label variable hy022 "Tt dsp hh inc bf soc trnfs ex o-age & srvvrs ben (DE,EE,FR,IE,MT,SI,UK:modified)" 
label variable hy022_f "Flag" 
label variable hy022_i "Imputation factor" 
label variable hy023 "Tt dsp hh inc bf soc trnfs ic o-age & srvvrs ben (DE,EE,FR,IE,MT,SI,UK:modified)" 
label variable hy023_f "Flag" 
label variable hy023_i "Imputation factor" 
label variable hy040n "Income from rental of a property or land (net; DE SI: Top cod, FR,IE: rounded)" 
label variable hy040n_f "Flag" 
label variable hy040n_i "Imputation factor" 
label variable hy050n "Family/Children related allowances (net; SI: Top coding)" 
label variable hy050n_f "Flag" 
label variable hy050n_i "Imputation factor" 
label variable hy060n "Social exclusion not elsewhere classified (net; SI: Top coding)" 
label variable hy060n_f "Flag" 
label variable hy060n_i "Imputation factor" 
label variable hy070n "Housing allowances (net; SI: Top coding)" 
label variable hy070n_f "Flag" 
label variable hy070n_i "Imputation factor" 
label variable hy080n "Regular interhousehold cash received (net; SI: Top coding, FR,IE: rounded)" 
label variable hy080n_f "Flag" 
label variable hy080n_i "Imputation factor" 
label variable hy081n "Alimonies received (net; SI: Top coding, FR,IE: rounded)" 
label variable hy081n_f "Flag" 
label variable hy081n_i "Imputation factor" 
label variable hy090n "Intrsts, dvdnds, pr fr cptl invmnt in uncp bsn (DE,FR,IE,MT,SI,UK: modified)" 
label variable hy090n_f "Flag" 
label variable hy090n_i "Imputation factor" 
label variable hy100n "Interest repayment on mortgage (net)" 
label variable hy100n_f "Flag" 
label variable hy100n_i "Imputation factor" 
label variable hy110n "Income received by people aged under 16 (net; SI: Top coding)" 
label variable hy110n_f "Flag" 
label variable hy110n_i "Imputation factor" 
label variable hy120n "Regular taxes on wealth (net; SI: Top coding)" 
label variable hy120n_f "Flag" 
label variable hy120n_i "Imputation factor" 
label variable hy130n "Regular inter-household cash transfer paid (net; SI: Top coding, FR,IE: rounded)" 
label variable hy130n_f "Flag" 
label variable hy130n_i "Imputation factor" 
label variable hy131n "Alimonies paid (net; SI: Top coding, FR,IE: rounded)" 
label variable hy131n_f "Flag" 
label variable hy131n_i "Imputation factor" 
label variable hy140n "Tax on income and social contribution (net; DE: Top & bottom coding; MT: Adj)" 
label variable hy140n_f "Flag" 
label variable hy140n_i "Imputation factor" 
label variable hy145n "Repayments or receipts for tax adjustment (net; SI: Top & bot cod, FR,IE: round)" 
label variable hy145n_f "Flag" 
label variable hy145n_i "Imputation factor" 
label variable hy170n "Value of goods produced for own consumption (net)" 
label variable hy170n_f "Flag" 
label variable hy170n_i "Imputation factor" 
label variable hy121n "Taxes paid on ownership of household main dwelling" 
label variable hy121n_f "Flag" 
label variable hy040g "Income from rental of a property or land (gross, DE,FR,IE,MT,SI: modified)" 
label variable hy040g_f "Flag" 
label variable hy040g_i "Imputation factor" 
label variable hy050g "Family/Children related allowances (gross; SI: Top cod; MT: Top & bottom cod)" 
label variable hy050g_f "Flag" 
label variable hy050g_i "Imputation factor" 
label variable hy060g "Social exclusion not elsewhere classified (gross; SI: Top coding; MT: T & b cod)" 
label variable hy060g_f "Flag" 
label variable hy060g_i "Imputation factor" 
label variable hy070g "Housing allowances (gross; SI: Top coding; MT: Top & bottom coding)" 
label variable hy070g_f "Flag" 
label variable hy070g_i "Imputation factor" 
label variable hy080g "Regular interhousehold cash transfer received (gross; FR,IE,MT,SI:modified)" 
label variable hy080g_f "Flag" 
label variable hy080g_i "Imputation factor" 
label variable hy081g "Alimonies received (gross; SI: Top coding; MT: Top & bottom cod, FR,IE: rounded)" 
label variable hy081g_f "Flag" 
label variable hy081g_i "Imputation factor" 
label variable hy090g "Intrsts, dvdnds, pr fr cptl invmnt in uncrpbsn (DE,FR,IE,MT,SI,UK: modified)" 
label variable hy090g_f "Flag" 
label variable hy090g_i "Imputation factor" 
label variable hy100g "Interest repayments on mortgage (gross, MT: Top & bottom coding)" 
label variable hy100g_f "Flag" 
label variable hy100g_i "Imputation factor" 
label variable hy110g "Income received by people aged under 16 (gross; SI: Top coding, MT: T & b cod)" 
label variable hy064g_f "Flag" 
label variable hy071g "Housing allowances (contributory and means-tested)" 
label variable hy071g_f "Flag" 
label variable hy072g "Housing allowances (contributory and non means-tested)" 
label variable hy072g_f "Flag" 
label variable hy073g "Housing allowances (non-contributory and means-tested, MT: T & b cod)" 
label variable hy073g_f "Flag" 
label variable hy074g "Housing allowances (non-contributory and non means-tested, MT: T & b cod)" 
label variable hy074g_f "Flag" 
label variable hs011 "Arrears on mortgage or rent payments" 
label variable hs011_f "Flag" 
label variable hs021 "Arrears on utility bills" 
label variable hs021_f "Flag" 
label variable hs022 "Reduced utility costs" 
label variable hs022_f "Flag" 
label variable hs031 "Arrears on hire purchase installments or other loan payments" 
label variable hs031_f "Flag" 
label variable hs040 "Capacity to afford paying for one week annual holiday away from home" 
label variable hs040_f "Flag" 
label variable hs050 "Capacity to afford a meal with meat, chicken, fish (or veg. equiv.) ev. sec. day" 
label variable hs050_f "Flag" 
label variable hs060 "Capacity to face unexpected financial expenses" 
label variable hs060_f "Flag" 
label variable hs090 "Do you have a computer?" 
label variable hs090_f "Flag" 
label variable hs110 "Do you have a car?" 
label variable hs110_f "Flag" 
label variable hs120 "Ability to make ends meet" 
label variable hs120_f "Flag" 
label variable hs150 "Financial burden of the repayment of debts from hire purchases or loans" 
label variable hs150_f "Flag" 
label variable hh010 "Dwelling type (5 coded as missing)" 
label variable hh010_f "Flag" 
label variable hh021 "Tenure status" 
label variable hy110g_f "Flag" 
label variable hy110g_i "Imputation factor" 
label variable hy120g "Regular taxes on wealth (gross; SI, UK: Top coding, EE: Adj)" 
label variable hy120g_f "Flag" 
label variable hy120g_i "Imputation factor" 
label variable hy130g "Regular interhousehold cash transfer paid (gross; FR,IE,MT,SI: modified)" 
label variable hy130g_f "Flag" 
label variable hy130g_i "Imputation factor" 
label variable hy131g "Alimonies paid (gross; SI: Top coding, MT: Top & bottom coding, FR,IE: rounded)" 
label variable hy131g_f "Flag" 
label variable hy131g_i "Imputation factor" 
label variable hy140g "Tax on inc and soc contributions (gross; UK: T cod; DE, MT: T & b cod; EE: Adj)" 
label variable hy140g_f "Flag" 
label variable hy140g_i "Imputation factor" 
label variable hy170g "Value of goods produced for own consumption (gross)" 
label variable hy170g_f "Flag" 
label variable hy170g_i "Imputation factor" 
label variable hy121g "Taxes paid on ownership of household main dwelling" 
label variable hy121g_f "Flag" 
label variable hy051g "Family/children-related allowances (contributory and means-tested)" 
label variable hy051g_f "Flag" 
label variable hy052g "Family/children-related allowances (contributory & n. means-tstd, MT: T & b cod)" 
label variable hy052g_f "Flag" 
label variable hy053g "Family/children-related allow. (non-contributory & means-tested, MT: T & b cod)" 
label variable hy053g_f "Flag" 
label variable hy054g "Family/children-related allowance (non-cntrbtry & n. means-tstd, MT: T & b cod)" 
label variable hy054g_f "Flag" 
label variable hy061g "Social exclusion not elsewhere classified (contributory and means-tested)" 
label variable hy061g_f "Flag" 
label variable hy062g "Social exclusion not elsewhere classified (contributory and non means-tested)" 
label variable hy062g_f "Flag" 
label variable hy063g "Social exclusion not elsewhere class. (non-cntrbtry & means-tstd, MT: T & b cod)" 
label variable hy063g_f "Flag" 
label variable hy064g "Social exclusion not elsewhere classified (non-contributory & non means-tested)" 
label variable hh021_f "Flag" 
label variable hh030 "Number of rooms available to the household" 
label variable hh030_f "Flag" 
label variable hh050 "Ability to keep home adequately warm" 
label variable hh050_f "Flag" 
label variable hh060 "Current rent related to occupied dwelling (MT: Top & bottom coding)" 
label variable hh060_f "Flag" 
label variable hh070 "Total housing cost (MT: Top & bottom coding)" 
label variable hh070_f "Flag" 
label variable hh071 "Mortgage principal repayment (MT: Top & bottom coding)" 
label variable hh071_f "Flag" 
label variable hd080 "Replacing worn-out furniture" 
label variable hd080_f "Flag" 
label variable hi010 "Change in the household income compared to previous year" 
label variable hi010_f "Flag" 
label variable hi020 "Reason for increase in income" 
label variable hi020_f "Flag" 
label variable hi030 "Reason for decrease in income" 
label variable hi030_f "Flag" 
label variable hch010 "Unmet need for medical examination or treatment (children)" 
label variable hch010_f "Flag" 
label variable hch020 "Main reason for unmet need for medical examination or treatment (children)" 
label variable hch020_f "Flag" 
label variable hch030 "Unmet need for dental examination or treatment (children)" 
label variable hch030_f "Flag" 
label variable hch040 "Main reason for unmet need for dental examination or treatment (children)" 
label variable hch040_f "Flag" 
label variable hd100 "Some new (not second-hand) clothes" 
label variable hd100_f "Flag" 
label variable hd110 "Two pairs of properly fitting shoes (including a pair of all-weather shoes)" 
label variable hd110_f "Flag" 
label variable hd120 "Fruits and vegetables once a day" 
label variable hd120_f "Flag" 
label variable hd140 "One meal with meat, chicken or fish (or vegetarian equivalent) >= once a day" 
label variable hd140_f "Flag" 
label variable hd150 "Books at home suitable for their age" 
label variable hd150_f "Flag" 
label variable hd160 "Outdoor leisure equipment" 
label variable hd160_f "Flag" 
label variable hd170 "Indoor games" 
label variable hd170_f "Flag" 
label variable hd180 "Regular leisure activity" 
label variable hd180_f "Flag" 
label variable hd190 "Celebration on special occasions" 
label variable hd190_f "Flag" 
label variable hd200 "Invite friends round to play or eat from time to time" 
label variable hd200_f "Flag" 
label variable hd210 "Participate in school trips and school events that cost money" 
label variable hd210_f "Flag" 
label variable hd220 "Suitable place to study or do homework" 
label variable hd220_f "Flag" 
label variable hd240 "Go on holiday away from home at least one week per year" 
label variable hd240_f "Flag" 
