label define rb200 1 "Currently living in the household" 2 "Temporarily absent"
label define rb211 1 "Employed" 2 "Unemployed" 3 "Retired" 4 "Unable to work due to long-standing health problems" 5 "Student, pupil" 6 "Fulfilling domestic tasks" 7 "Compulsory military or civilian service" 8 "Other"
label define rx050 0 "No low work intensity" 1 "Low work intensity" 2 "Not applicable"
label define rx060 0 "Not severely deprived" 1 "Severely deprived"
label define rx070 0 "Not ARP/not severely materially deprived/no low work intensity" 1 "Not ARP/not severely materially deprived/low work intensity" 10 "Not ARP/severely materially deprived/no low work intensity" 11 "Not ARP/severely materially deprived/low work intensity" 100 "ARP/not severely materially deprived/no low work intensity" 101 "ARP/not severely materially deprived/low work intensity" 110 "ARP/severely materially deprived/no low work intensity" 111 "ARP/severely materially deprived/low work intensity"

label values rb211 rb211
label values rx050 rx050
label values rx060 rx060
label values rx070 rx070

label variable rb010 "Year of the survey" 
label variable rb020 "Country alphanumeric" 
label variable rb030 "Personal ID" 
label variable rb050 "Personal cross-sectional weight" 
label variable rb050_f "Flag" 
label variable rb051 "Regional weight" 
label variable rb051_f "Flag" 
label variable rb065 "Longitudinal weight (five-year duration)" 
label variable rb065_f "Flag" 
label variable rb066 "Longitudinal weight (six-year duration)" 
label variable rb066_f "Flag" 
label variable rb081 "Age in completed years (at the end of income reference period) (IT,MT: removed)" 
label variable rb081_f "Flag" 
label variable rb082 "Age in completed years at the time of the interview (IT,MT: removed)" 
label variable rb082_f "Flag" 
label variable rb080 "Year of birth (MT: 5 yr groups)" 
label variable rb080_f "Flag" 
label variable rb090 "Sex (DE, SI: in same sex HH: recoded gender)" 
label variable rb090_f "Flag" 
label variable rb200 "Residential status" 
label variable rb200_f "Flag" 
label variable rb211 "Main activity status (self-defined)" 
label variable rb211_f "Flag" 
label variable rb220 "Father ID" 
label variable rb220_f "Flag" 
label variable rb230 "Mother ID" 
label variable rb230_f "Flag" 
label variable rb240 "Spouse/Partner ID" 
label variable rb240_f "Flag" 
label variable rb245 "Respondent status" 
label variable rb245_f "Flag" 
label variable rb250 "Data status" 
label variable rb250_f "Flag" 
label variable rb280 "Country of birth (grouped) (EE,IT,LV,MT,SI: EU -> OTH)" 
label variable rb280_f "Flag" 
label variable rb285 "Duration of stay in the country of residence in completed years" 
label variable rb285_f "Flag" 
label variable rb290 "Country of main citizenship (grouped) (EE,LV,MT,SI: EU -> OTH)" 
label variable rb290_f "Flag" 
label variable rl010 "Education at pre-school: hours of education during an usual week" 
label variable rl010_f "Flag" 
label variable rl020 "Education at compulsory school: hours of education during an usual week" 
label variable rl020_f "Flag" 
label variable rl030 "Childcare at centre-based services: hours of child care during an usual week" 
label variable rl030_f "Flag" 
label variable rl040 "Childcare at day-care centre: hours of child care during an usual week" 
label variable rl040_f "Flag" 
label variable rl050 "Child care by a professional child-miner: No. h of child care during usual week" 
label variable rl050_f "Flag" 
label variable rl060 "Child care by grnd-prnts; oth. hhld mmbrs; rltvs etc: No. of h/usual week" 
label variable rl060_f "Flag" 
label variable rl070 "Children cross-sectional weight for child care" 
label variable rl070_f "Flag" 
label variable rb032 "Sequential number of the persons in the household (IT: not provided)" 
label variable rb032_f "Flag" 
label variable rg_1 "Household grid person 1 (DE,IT: not provided)" 
label variable rg_1_f "Flag" 
label variable rg_2 "Household grid person 2 (DE,IT: not provided)" 
label variable rg_2_f "Flag" 
label variable rg_3 "Household grid person 3 (DE,IT: not provided)" 
label variable rg_3_f "Flag" 
label variable rg_4 "Household grid person 4 (DE,IT: not provided)" 
label variable rg_4_f "Flag" 
label variable rg_5 "Household grid person 5 (DE,IT: not provided)" 
label variable rg_5_f "Flag" 
label variable rg_6 "Household grid person 6 (DE,IT: not provided)" 
label variable rg_6_f "Flag" 
label variable rg_7 "Household grid person 7 (DE,IT: not provided)" 
label variable rg_7_f "Flag" 
label variable rg_8 "Household grid person 8 (DE,IT: not provided)" 
label variable rg_8_f "Flag" 
label variable rg_9 "Household grid person 9 (DE,IT: not provided)" 
label variable rg_9_f "Flag" 
label variable rg_10 "Household grid person 10 (DE,IT: not provided)" 
label variable rg_10_f "Flag" 
label variable rg_11 "Household grid person 11 (DE,IT: not provided)" 
label variable rg_11_f "Flag" 
label variable rg_12 "Household grid person 12 (DE,IT: not provided)" 
label variable rg_12_f "Flag" 
label variable rg_13 "Household grid person 13 (DE,IT: not provided)" 
label variable rg_13_f "Flag" 
label variable rg_14 "Household grid person 14 (DE,IT: not provided)" 
label variable rg_14_f "Flag" 
label variable rg_15 "Household grid person 15 (DE,IT: not provided)" 
label variable rg_15_f "Flag" 
label variable rg_16 "Household grid person 16 (DE,IT: not provided)" 
label variable rg_16_f "Flag" 
label variable rg_17 "Household grid person 17 (DE,IT: not provided)" 
label variable rg_17_f "Flag" 
label variable rg_18 "Household grid person 18 (DE,IT: not provided)" 
label variable rg_18_f "Flag" 
label variable rg_19 "Household grid person 19 (DE,IT: not provided)" 
label variable rg_19_f "Flag" 
label variable rg_20 "Household grid person 20 (DE,IT: not provided)" 
label variable rg_20_f "Flag" 
label variable rch010 "General health (child)" 
label variable rch010_f "Flag" 
label variable rch020 "Limitation in activities because of health problems (child)" 
label variable rch020_f "Flag" 
label variable rk010 "Parent ID and sequential number of the child who is not household member" 
label variable rk010_f "Flag" 
label variable rk020 "Age of the child who is not household member" 
label variable rk020_f "Flag" 
label variable rk030 "Usual time the parent needs to get to the child who is not a household member" 
label variable rk030_f "Flag" 
label variable rk040 "Freq of contact (via phone, social media etc.) last 12 months with child ex hh" 
label variable rk040_f "Flag" 
label variable rk050 "Child having a bedroom in which to sleep (incl bedroom shared with siblings)" 
label variable rk050_f "Flag" 
label variable rk060 "Freq of spending actively time w/ child (meals, play, homework, walk, talk etc.)" 
label variable rk060_f "Flag" 
label variable rk070 "Number of nights per month the child spends in the household (average)" 
label variable rk070_f "Flag" 
label variable rk080 "Legal child custody situation" 
label variable rk080_f "Flag" 
label variable rx010 "Age at the date of the interview (MT: missing)" 
label variable rx020 "Age at the end of the income reference period (MT: missing, FI: perturb)" 
label variable rx030 "Household ID" 
label variable rx040 "Work intensity" 
label variable rx050 "Low work intensity status" 
label variable rx060 "Severely materially deprived household" 
label variable rx070 "At risk of poverty or social exclusion" 
